1. [常见的元字符和特征](https://github.com/LbhFront-end/About-Regular-Expression/blob/master/About-Regular-Expression-Part3.md#常见的元字符和特征)  
   (1)[字符表示法](https://github.com/LbhFront-end/About-Regular-Expression/blob/master/About-Regular-Expression-Part3.md#字符表示法)  
   (2)[字符组成及相关结构](https://github.com/LbhFront-end/About-Regular-Expression/blob/master/About-Regular-Expression-Part3.md#字符组成及相关结构)  
   (3)[注释和模式修饰符](https://github.com/LbhFront-end/About-Regular-Expression/blob/master/About-Regular-Expression-Part3.md#注释和模式修饰符)  
   (4)[分组，捕获，条件判断和控制](https://github.com/LbhFront-end/About-Regular-Expression/blob/master/About-Regular-Expression-Part3.md#分组捕获条件判断和控制)   

   

## 精通正则表达式第三版（笔记）第三章

## 正则表示式的特性和流派概念

前几节依次是 **在正则的世界中漫步**、**正则表达式的注意事项和处理方式**、**字符串、字符编码和匹配**，主要是通过讲解比较不同的语言下面的正则表达式的起源，作用，区别。比较生涩难懂，就不作总结，有兴趣的可以自己去百度搜索这本书。



## 常见的元字符和特征

本节介绍的结构

#### 字节表示法

| 描述                   | 例子                                                |
| ---------------------- | --------------------------------------------------- |
| 字符缩略表示法         | `\n`、`\t`、`\a`、`\b`、`\e`、`\f`、`\r`、`\v`、... |
| 八进制转义             | `\num`                                              |
| 十六进制`/Uincode`转义 | `\xnum`、`\x(num)`、`\unum`、`\Unum`、...           |
| 控制字符               | `\cchar`                                            |

#### 字符以相关结构

| 描述                             | 例子                               |
| -------------------------------- | ---------------------------------- |
| 普通字符组                       | `[a-z]`和`\[^ z-a]`                |
| 几乎能匹配任何字符的元字符       | 点号                               |
| 单个字节                         | `\C`                               |
| Unicode组合字符序列              | `\x`                               |
| 字符组缩略表示法                 | `\w`、`\d`、`\s`、`\W`、`\D`、`\S` |
| Unicode属性、区块和分类          | `\p(Prop)`、`\P(Prop)`             |
| 字符组运算符                     | `[a-z]&&\[^aeiou]`                 |
| POSIX“字符组”方括号表示法        | `[:alpha:]`                        |
| POSIX“collating序列”方括号表示法 | `[.span-ll]`                       |
| POSIX“字符等价类”方括号表示法``  | `[=n=]`                            |
| Emacs语法类                      |                                    |

#### 锚点及其他“零长度断言”

| 描述                                         | 例子                      |
| -------------------------------------------- | ------------------------- |
| 行/字符串起点                                | `^`、`\A`                 |
| 行/字符串终点                                | `$`、`\Z`、`\z`           |
| 本次匹配的开始位置（或者上次匹配的结束位置） | `\G`                      |
| 单词分界符                                   | `\b`、`\B`、`\<`、`\>`... |
| 顺序环视                                     | `(?=...)`、`(?!...)`      |
| 逆序环视                                     | `(?<=...)`、`(?<!...)`    |

#### 注释和模式修饰词

| 描述         | 例子               |
| ------------ | ------------------ |
| 模式修饰词   | `(?modifier)`      |
| 模式作用范围 | `(?modifier:...)`  |
| 注释         | `(?#...)`和 `#...` |
| 文字文本范围 | `\Q...\E`          |

#### 分组，捕获，条件判断和控制 

| 描述             | 例子                            |
| ---------------- | ------------------------------- |
| 捕获/分组括号    | `(...)`、`\1`、`\2`、...        |
| 仅用于分组的括号 | `(?:...)`                       |
| 命名捕获         | `(?<Name>...)`                  |
| 固化分组         | `(?>...)`                       |
| 多选结构         | `...|...|....`                  |
| 条件判断         | `(?if then |else)`              |
| 匹配优先量词     | `*`、`+` 、`?`、`{num,num}`     |
| 忽略优先量词     | `*?`、`+?` 、`??`、`{num,num}?` |
| 占有优先量词     | `*+`、`++` 、`?+`、`{num,num}+` |

### 字符表示法

这一组元字符能够以清晰美观的方式匹配其他方式中很难描述的某些字符

#### 字符缩略表示法

许多工具软件提供了表示某些控制字符的元字符，其中有一些在所有机器上都是不变的，但也有些是很难输入或观察的

| 字符 | 代表       | ASCLL        | 八进制编码 | 描述                                                         |
| ---- | ---------- | ------------ | ---------- | ------------------------------------------------------------ |
| `\a` | 警报       | \<BEL>       | 007        | 例如，在打印时扬声器发声                                     |
| `\b` | 退格       | \<BS>        | 010        | 在很多流派中，`\b`只有在字符组内部才有这样的意义，否则代表单词分界符 |
| `\e` | Escape字符 | \<ESC>       | 033        | \                                                            |
| `\f` | 进纸符     | \<FF>        | 014        | \                                                            |
| `\n` | 换行符     | \<LF>\|\<CR> | 012\|015   | 后面的是MacOs系统的                                          |
| `\r` | 回车       | \<CR>\|\<LF> | \          | 后面的是MacOs系统的                                          |
| `\t` | 水平制表符 | \<HT>        | 011        | \                                                            |
| `\v` | 垂直制表符 | \<VT>        | 013        | \                                                            |

从上表可以看出， `\n`和 `\r`的意义是随着操作系统的变化而变化的，如果要在所有的平台上面都能通用的“换行符”，请使用 `\n`。

### 字符组成及相关结构

#### 字符组简记法

| 简记法 | 代表         | 描述                                               |
| ------ | ------------ | -------------------------------------------------- |
| `\d`   | 数字         | 等价于 `[0-9]`                                     |
| `\D`   | 非数字符号   | 等价于 `[^\d]`                                     |
| `\w`   | 单词中的字符 | 一般等价于 `[a-zA-Z0-9]`，通常表示所有的数字和字符 |
| `\W`   | 非单词字符   | 等价于 `[^\w]`                                     |
| `\s`   | 空白字符     | 通常等价于 `[ \f\n\r\t\v]`                         |
| `\S`   | 非空白字符   | 等价于 `[^\s]`                                     |

### 注释和模式修饰符

#### 模式修饰符

| 字母 | 模式                   |
| ---- | ---------------------- |
| i    | 不区分大小写的匹配模式 |
| x    | 宽松排列和注释模式     |
| s    | 点号通配模式           |
| m    | 增强的行锚点模式       |



### 分组，捕获，条件判断和控制 

#### 条件判断：（？if then | else）

```
(<A\s+[^>]+> \s*>)?	# 匹配开头的<A> tag，如果存在的话
<IMG\s+[^>]+>	    # 匹配<IMG> tag
(?(1)\s*</A>)	    # 匹配结尾的</A>，如果之前匹配过<A>
```



[上一章](https://github.com/LbhFront-end/About-Regular-Expression/blob/master/About-Regular-Expression-Part2.md)
[下一章](https://github.com/LbhFront-end/About-Regular-Expression/blob/master/About-Regular-Expression-Part4.md) 